#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum AlertType {
    #[serde(rename = "INVALID")]
    Invalid,
    #[serde(rename = "FAILURE")]
    Failure,
    #[serde(rename = "RECOVERY")]
    Recovery,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl AlertType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            AlertType::Invalid => "INVALID",
            AlertType::Failure => "FAILURE",
            AlertType::Recovery => "RECOVERY",
            AlertType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for AlertType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for AlertType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for AlertType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<AlertType, conjure_object::plain::ParseEnumError> {
        match v {
            "INVALID" => Ok(AlertType::Invalid),
            "FAILURE" => Ok(AlertType::Failure),
            "RECOVERY" => Ok(AlertType::Recovery),
            v => v.parse().map(|v| AlertType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for AlertType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<AlertType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the AlertType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
